#ifndef _DAQBuilderBuilderActionCommand_HH_
#define _DAQBuilderBuilderActionCommand_HH_
#include <Command/DAQBuilderCommand.hh>

namespace DAQBuilder 
{
  class ActionCommand : public Command
  {
  protected:
      void              _setType();
      void              _setParentClasses();
  public :
    ActionCommand();
    ActionCommand( const ActionCommand& right );
    virtual ~ActionCommand();
    ActionCommand& operator=( const ActionCommand & right);
  public:
    void executeCommand( const StringList & arguments )
      throw(CommandException *);
  };
  inline void   ActionCommand::_setParentClasses()
  {
    _parentClasses.insert("Object");
    _parentClasses.insert("Command");
  }
  inline void   ActionCommand::_setType()
  {
    this -> _type = "ActionCommand";
  }
}
#endif
