#include<Run/DAQBuilderAction.hh>
#include<System/DAQBuilderSystem.hh>
#include<System/DAQBuilderClassLoader.hh>
#include<System/DAQBuilderActionRegistry.hh>
#include<Instance/DAQBuilderInstance.hh>
#include<Primitives/DAQBuilderInteger.hh>
#include<Command/DAQBuilderClearActionRegistryCommand.hh>
namespace DAQBuilder
{
  ClearActionRegistryCommand::ClearActionRegistryCommand()
    :Command("")
  {
    _setType();
    _setParentClasses();
  }
  ClearActionRegistryCommand::ClearActionRegistryCommand( const ClearActionRegistryCommand& right )
    :Command(*((Command*)&right))
  {
    
  }
  ClearActionRegistryCommand::~ClearActionRegistryCommand()
  {
  }
  ClearActionRegistryCommand& ClearActionRegistryCommand::operator=( const ClearActionRegistryCommand & right)
  {
    *((Command*)this) = *((Command*)&right);
    return *this;
  }
  void ClearActionRegistryCommand::executeCommand( const StringList & arguments )
    throw (CommandException * )
  {
    if(!arguments.empty())
      {
      CommandException * e = 
	new CommandException("invalid number of arguments!");   
      e -> insert("Location","ClearActionRegistryCommand::operator()( const StringList& )");
      e -> insert("Usage : ","ClearActionRegistry"+_help);
      throw e;
      }
    try{
      ActionRegistry::clear();
    }catch (Exception * ex ){
      CommandException * e = 
	new CommandException("error occured");   
      e -> insert("Location","ClearActionRegistryCommand::operator()( const StringList& )");
      e -> insert("Error   : ",ex->toString());
      throw e;
    }
  }
}
