#ifndef _DAQBuilderBuilderClearObjectRegistryCommand_HH_
#define _DAQBuilderBuilderClearObjectRegistryCommand_HH_
#include <Command/DAQBuilderCommand.hh>

namespace DAQBuilder 
{
  class ClearObjectRegistryCommand : public Command
  {
  protected:
      void              _setType();
      void              _setParentClasses();
  public :
    ClearObjectRegistryCommand();
    ClearObjectRegistryCommand( const ClearObjectRegistryCommand& right );
    virtual ~ClearObjectRegistryCommand();
    ClearObjectRegistryCommand& operator=( const ClearObjectRegistryCommand & right);
  public:
    void executeCommand( const StringList & arguments )
      throw(CommandException *);
  };
  inline void   ClearObjectRegistryCommand::_setParentClasses()
  {
    _parentClasses.insert("Object");
    _parentClasses.insert("Command");
  }
  inline void   ClearObjectRegistryCommand::_setType()
  {
    this -> _type = "ClearObjectRegistryCommand";
  }
}
#endif
