#include<Run/DAQBuilderAction.hh>
#include<System/DAQBuilderSystem.hh>
#include<System/DAQBuilderClassLoader.hh>
#include<System/DAQBuilderRunRegistry.hh>
#include<Instance/DAQBuilderInstance.hh>
#include<Primitives/DAQBuilderInteger.hh>
#include<Command/DAQBuilderClearRunRegistryCommand.hh>
namespace DAQBuilder
{
  ClearRunRegistryCommand::ClearRunRegistryCommand()
    :Command("")
  {
    _setType();
    _setParentClasses();
  }
  ClearRunRegistryCommand::ClearRunRegistryCommand( const ClearRunRegistryCommand& right )
    :Command(*((Command*)&right))
  {
    
  }
  ClearRunRegistryCommand::~ClearRunRegistryCommand()
  {
  }
  ClearRunRegistryCommand& ClearRunRegistryCommand::operator=( const ClearRunRegistryCommand & right)
  {
    *((Command*)this) = *((Command*)&right);
    return *this;
  }
  void ClearRunRegistryCommand::executeCommand( const StringList & arguments )
    throw (CommandException * )
  {
    if(!arguments.empty())
      {
      CommandException * e = 
	new CommandException("invalid number of arguments!");   
      e -> insert("Location","ClearRunRegistryCommand::operator()( const StringList& )");
      e -> insert("Usage : ","ClearRunRegistry"+_help);
      throw e;
      }
    try{
      RunRegistry::clear();
    }catch (Exception * ex ){
      CommandException * e = 
	new CommandException("error occured");   
      e -> insert("Location","ClearRunRegistryCommand::operator()( const StringList& )");
      e -> insert("Error   : ",ex->toString());
      throw e;
    }
  }
}
