#include<Run/DAQBuilderRun.hh>
#include<System/DAQBuilderSystem.hh>
#include<System/DAQBuilderClassLoader.hh>
#include<System/DAQBuilderRunRegistry.hh>
#include<Instance/DAQBuilderInstance.hh>
#include<Primitives/DAQBuilderInteger.hh>
#include<Command/DAQBuilderDeleteRunCommand.hh>
namespace DAQBuilder
{
  DeleteRunCommand::DeleteRunCommand()
    :Command("<runName>")
  {
    _setType();
    _setParentClasses();
  }
  DeleteRunCommand::DeleteRunCommand( const DeleteRunCommand& right )
    :Command(*((Command*)&right))
  {
    
  }
  DeleteRunCommand::~DeleteRunCommand()
  {
  }
  DeleteRunCommand& DeleteRunCommand::operator=( const DeleteRunCommand & right)
  {
    *((Command*)this) = *((Command*)&right);
    return *this;
  }
  void DeleteRunCommand::executeCommand( const StringList & arguments )
    throw (CommandException * )
  {
    if(arguments.size() != 1 ){
      CommandException * e = 
	new CommandException("invalid number of arguments!");   
      e -> insert("Location","DeleteRunCommand::operator()( const StringList& )");
      e -> insert("Usage : ","DeleteRun"+_help);
      throw e;
    }
    try{
      RunRegistry::unbind( arguments[0] );
    }catch (Exception * ex ){
      CommandException * e = 
	new CommandException("error occured");   
      e -> insert("Location","DeleteobjectCommand::operator()( const StringList& )");
      e -> insert("Error   : ",ex->toString());
      throw e;
    }
  }
}
