#include <System/DAQBuilderStopWatch.hh>
namespace DAQBuilder
{
  DBool             StopWatch::equals( const StopWatch& right )
  {
    DBool aBool      = _status         ==     right._status;
    return aBool;
  }
  DBool             StopWatch::equals( const Object * right )
  {
    if(!findParent(_type,right))
         return false;
    return equals(*((StopWatch*)right));
  }
  DBool   StopWatch::operator   ==(const StopWatch & right ) const 
  {
    DBool aBool = *((Object*)this) ==  *((Object*)&right);
    aBool      |= _status          ==  right._status;
    return aBool;
  }
  DBool   StopWatch::operator   !=(const StopWatch & right ) const 
  {
    DBool aBool = *((Object*)this) !=  *((Object*)&right);
    aBool      |= _status          !=  right._status;
    return aBool;
  }
  StopWatch::StopWatch()
    :Object(),_status(StopWatch::Shutdown)
  {
    _setType();
    _setParentClasses();
  }
  StopWatch::StopWatch( const StopWatch& right )
    :Object(*((Object*)&right)),
     _status(right._status)
  {
  }
  StopWatch::~StopWatch()
  {
    _finalize();
  }
  StopWatch& StopWatch::operator   =(const StopWatch & right )
  {
    *((Object*)this)=    *((Object*)&right);
    _status         =     right._status;
    return *this;
  }
}
