#ifndef __DAQBuilderGZipInputStream_HH__
#define __DAQBuilderGZipInputStream_HH__
#include <System/IO/DAQBuilderInflaterInputStream.hh>
#include <System/DAQBuilderGZipInflater.hh>
#include <Exception/DAQBuilderIOException.hh>

namespace DAQBuilder
{
  class GZipInputStream : public InflaterInputStream
  {
  protected:
    void                            _setType();
    void                            _setParentClasses();
  public:
//    const  DString                  toString() const ;
  public :
    GZipInputStream( InputStream  * _inputStream ,
                     GZipInflater * _inflater = new GZipInflater() );
    GZipInputStream( const GZipInputStream& right );
    ~GZipInputStream();
  public:    
    GZipInputStream& operator   =(const GZipInputStream & right );
  };
  inline void   GZipInputStream::_setParentClasses()
  {
    _parentClasses.insert("Object");
    _parentClasses.insert("InputStream");
    _parentClasses.insert("FilterInputStream");
    _parentClasses.insert("InfaterInputStream");
  }
  inline void   GZipInputStream::_setType()
  {
    this -> _type = "GZipInputStream";
  }
}
#endif
