#ifndef __DAQBuilderGZipOutputStream_HH__
#define __DAQBuilderGZipOutputStream_HH__
#include <System/IO/DAQBuilderDeflaterOutputStream.hh>
#include <System/DAQBuilderGZipDeflater.hh>
#include <Exception/DAQBuilderIOException.hh>

namespace DAQBuilder
{
  class GZipOutputStream : public DeflaterOutputStream
  {
  protected:
    void                            _setType();
    void                            _setParentClasses();
  public:
  //  const  DString                  toString() const ;
  public :
    GZipOutputStream( OutputStream * _outputStream ,
                      GZipDeflater * _deflater = new GZipDeflater());
    GZipOutputStream( const GZipOutputStream& right );
    ~GZipOutputStream();
  public:    
    GZipOutputStream& operator   =(const GZipOutputStream & right );
  };
  inline void   GZipOutputStream::_setParentClasses()
  {
    _parentClasses.insert("Object");
    _parentClasses.insert("OutputStream");
    _parentClasses.insert("FilterOutputStream");
    _parentClasses.insert("DeflaterOutputStream");
  }
  inline void   GZipOutputStream::_setType()
  {
    this -> _type = "GZipOutputStream";
  }
}
#endif
