#ifndef __DAQBuilderInetAdress_HH__
#define __DAQBuilderInetAdress_HH__
#include <DAQBuilderObject.hh>

namespace DAQBuilder
{
  class InetAdress : public Object 
  {
  private:
    static Properties        _properties; 
  private:
    void              _setType();
    void              _setParentClasses();
  private:
    static void              _update();
    static void       _setupEnvironmentValue();
  public:
    const  DString           toString() const ;
  public:
    static DULong            currentTimeMillis() ; 
    static void              exit( DInt status ) ;
    static const Properties& getProperties();
    static const DString&    getProperty( const DString & key ) ;
    static void              setProperties( Properties &  _properties );
    static void              setProperty( const DString& key , const DString&  value );
    static void              deleteProperty( const DString& key );
    static void              clearProperty();
  public :
    InetAdress();
    InetAdress( const InetAdress& right );
    ~InetAdress();
  public:    
    InetAdress& operator   =(const InetAdress & right );
  };
  inline void   InetAdress::_setParentClasses()
  {
    _parentClasses.insert("Object");
  }
  inline void   InetAdress::_setType()
  {
    this -> _type = "InetAdress";
  }
}
#endif
