#include <Util/DAQBuilderCommentSlashState.hh>
#include <Util/DAQBuilderCommentEraser.hh>
namespace DAQBuilder
{
  CommentSlashState::CommentSlashState()
    :CommentStateBase()
  {
    _setType();
    _setParentClasses();
  }
  CommentSlashState::~CommentSlashState()
  {
    _finalize();
  }
  CommentSlashState::CommentSlashState( const CommentSlashState& right )
    :CommentStateBase(*((CommentStateBase*)&right))
  {
  }
  CommentSlashState& CommentSlashState::operator=( const CommentSlashState& right )
  {
    *((CommentStateBase*)this) =  *((CommentStateBase*)&right);
    return *this;
  }
  void CommentSlashState::process( CommentEraser& eraser)
  {
     char aChar = *eraser._index ; 
     /*eraser._source.erase(eraser._index);
     eraser._index--;*/
     if( aChar == gSlash){
        DString::iterator beginIter = eraser._index - 1; 
        DString::iterator endIter   = eraser._index + 1;
        eraser._source.erase( beginIter , endIter );
	eraser._index -= 2;
       eraser._status = eraser._state[ CommentEraser::SlashSlashState ];
     }else if(aChar == gStar ){
       eraser._status = eraser._state[ CommentEraser::StarState ];
     }else{
       eraser._status = eraser._state[ CommentEraser::normalState ];
     }
  }
}
